/*
 * parser.h -- part of ZilUtils/ZilAsm
 *
 * Copyright (C) 2016, 2019 Jason Self <j@jxself.org>
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 *
 * You should have received a copy of the GNU Affero General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>
 *
 * SPDX-License-Identifier: AGPL-3.0-or-later
 */

#ifndef ZILASM_PARSER
#define ZILASM_PARSER 1


struct Instruction
{
  Byte *pCodes;
  int size;
};

void init_parser ();

int parse_file (const char *filename);

extern unsigned g_numberOfInstructions;

#define MAX_NUMBER_OF_INSTRUCTIONS 65536
extern ZMemblock (*g_codes[MAX_NUMBER_OF_INSTRUCTIONS]);

#endif /* ifndef ZILASM_PARSER */
